<?php

require __DIR__ . "/vendor/autoload.php";
require __DIR__ . "/vendor/zeedhi/framework/bootstrap.php";
require __DIR__ . "/vendor/teknisa/libraries-next/scripts/bootstrap.php";

$instanceManager = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance();

$routes = array();
$routes[] = __DIR__ . '/vendor/teknisa/libraries-next/libRoutes.json';
$routes[] = __DIR__ . '/routes.json';

$instanceManager->loadFromFile(__DIR__ . '/config/db.xml');
$instanceManager->loadFromFile(__DIR__ . '/config/util.xml');
$instanceManager->loadFromFile(__DIR__ . '/config/general.xml');
$instanceManager->loadFromFile(__DIR__ . '/config/report.xml');
$instanceManager->loadFromFile(__DIR__ . '/config/parameters.xml');
$instanceManager->loadFromFile(__DIR__ . "/config/fileServer.xml");
$instanceManager->loadFromFile(__DIR__ . '/config/environment.xml');

$container = $instanceManager->getContainer();

$instanceManager->registerService('routeParser', new \Zeedhi\Framework\Routing\Parsers\JSONFormat($routes));

$instanceManager->compile();