import { ZdPage } from '@zeedhi/vue';
// import MainPage from '@/views/MainPage.vue';
import { Utilities } from '@/util/Utilities';

const routes = [
  {
    path: '/auth/login',
    name: 'login',
    component: ZdPage,
    props: {
      path: 'login',
      local: true,
    },
  },
  {
    path: '/home',
    name: 'no-dashboard',
    component: () => import('../views/MainPage.vue'),
  },
  {
    path: '/',
    name: 'home',
    redirect: () => {
      const util = new Utilities();
      if (util.moduleExists('parametersDashboard')) {
        return {
          path: '/modules/dsb/dashboardNext',
          alias: '/',
        };
      }
      return {
        path: '/home',
        alias: '/',
      };
    },
  },
  // {
  //   path: '/',
  //   name: 'home',
  //   component: () => import('../views/MainPage.vue'),
  // },
  {
    path: '/modules/:module/:page',
    name: 'microservice',
    component: () => import('../views/Microservice.vue'),
  },
  {
    path: '*',
    component: ZdPage,
    props: {
      path: 'notfound',
      local: true,
    },
  },
];

export default routes;
