import { I18n } from '@zeedhi/core';
import {
  DialogService,
} from '@zeedhi/common';

export class Utilities {
  public leaveDialogue: any = {
    click: () => DialogService.hide(),
  };

  public showDialog(actionConfirmed: any, data: any, type = 'OK') {
    if (type === 'YN' || type === 'YNA') {
      DialogService.show(this.createConfirmationDialog(actionConfirmed, data, type));
    } else {
      DialogService.show({
        name: 'observationDialogue',
        title: data.TITLE,
        text: data.MESSAGE,
        buttons: [
          {
            name: 'ok',
            component: 'ZdButton',
            label: 'OK',
            events: {
              click: () => DialogService.hide(),
            },
          },
        ],
      });
    }
  }

  public createConfirmationDialog(actionConfirmed: any, data: any, type: any) {
    const dialog = {
      name: 'buttons-dialog',
      type: 'warning',
      title: I18n.translate('gop::CONFIRM_OPERATION'),
      text: data.MESSAGE,
      buttons: [
        {
          name: 'noConfirmation',
          component: 'ZdButton',
          label: 'Não',
          events: this.leaveDialogue,
          outline: true,
        },
        {
          name: 'yesConfirmation',
          component: 'ZdButton',
          label: 'Sim',
          events: {
            click: () => actionConfirmed(data, 'S'),
          },
        },
      ],
    };
    if (type === 'YNA') {
      dialog.buttons[0].events = { click: () => actionConfirmed(data, 'N') };
      const cancel = {
        name: 'cancel',
        component: 'ZdButton',
        label: 'Cancelar',
        events: this.leaveDialogue,
        outline: true,
      };
      dialog.buttons.push(cancel);
    }
    return dialog;
  }

  public moduleExists(atribute: string) {
    const menu = JSON.parse(<string>localStorage.getItem('MENU'));
    let exists = false;
    if (menu) {
      // if menu exists then call the find operation, because if not. it'll break the whole system
      if (menu.find((obj: any) => obj.name === atribute)) {
        exists = true;
      }
    }
    return exists;
  }
}
